function checkShowHide(){
    var panels = document.getElementsByName("WhmcsAnalizerPanel");
    for (var i = 0; i < panels.length; ++i) {
        var temp = panels[i];
        var tBody = $(temp).children().last();
        var tRow = $(tBody).children().last();
        if(temp.offsetHeight > 350)
        {
            tRow.css("display", "");
            tRow.css({"cursor":"pointer"});
        }
    }    
}

var req; 

var reqProcesed;

var process;

var panlesShowed = false;

function init(){
    analyzerProcess();
}

function analyzerProcess(){
    beginStage(1, 0);
}

function beginStage($number, $process){
    
    process = $process;
    
    var params = "stage=" + $number + "&process=" + process + "&ajax=1";
    
    if(callAjax(params)){
        reqProcesed = $number;
        req.onreadystatechange = function() {
            if (req.readyState == 4 && req.status == 200) {
                reqProcesed = 0;
                processReqChange($number);
            }        
        }
    }
}

function callAjax(params){
    return loadXMLDoc(window.location.href+'?page=StepTwo', params);
}

function loadXMLDoc(url, params, callback)
{
  if(window.XMLHttpRequest) {
    try {
        req = new XMLHttpRequest();
    } catch(e) {
      req = false;
    }
  } else if(window.ActiveXObject) {
    try {
      req = new ActiveXObject("Msxml2.XMLHTTP");
    } catch(e) {
      try {
        req = new ActiveXObject("Microsoft.XMLHTTP");
      } catch(e) {
        req = false;
      }
    }
  }
  if(req) {
    req.open("POST", url, true);
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.send(params);
    return true;
  }
  return false;
}


function processReqChange($number) 
{
    if(req.readyState == 4 && req.status == 200) {
        var response  = req.responseXML.documentElement;
        var commands = response.getElementsByTagName('command');
        for(var i=0; i < commands.length; i++) {
            method = commands[i].getAttribute('method');
            switch(method) {
                case 'setproperty':
                    var target = getNodeValue(commands[i], 'target');
                    var property = getNodeValue(commands[i], 'property');
                    var value = getNodeValue(commands[i], 'value');
                    if(value == "true") value = true;
                    if(value == "false") value = false; 
                    if(target) {
                        if(property === 'class'){
                            document.getElementById(target).className = value;
                        }else if(property === 'content'){
                            document.getElementById(target).innerHTML = value;
                        }else if(property === 'width'){
                            document.getElementById(target).style.width= value;
                        }else if(property === 'error'){
                            showErrorMessage();                            
                        }else{
                            document.getElementById(target)[property] = value;
                        }
                    }
                    break;    
                default:
                    break;
            }
        }
            message = response.getElementsByTagName('message');  
            switch(message[0].firstChild.nodeValue) {
                case 'successProcess':
                    beginStage($number, process+1);
                    break;                  
                case 'success':
                    if($number ===14)
                    {break;}
                    beginStage($number+1, 0);
                    break;
                case 'error':
                    showErrorMessage();
                    beginStage($number, process+1);
                    break;   
                case 'finish':
                    setTimeout(function(){ 
                        stepThree();
                    }, 1000);
                    break;                  
                default:
                    break;
            }            
        
    }
}

function getNodeValue(parent, tagName)
{
  var node = parent.getElementsByTagName(tagName)[0];
  return (node && node.firstChild) ? node.firstChild.nodeValue : false;
}

function showPanel(ob)
{
    var panel = $(ob).parent().parent().parent();
    var rows = $(panel).children(); 
    $(panel).parent().parent().hide();    
    $(panel).css("max-height", "");  
    rows.first().css("max-height", "");
    var temp = rows.last().children();
    temp.first().html('<span style="color: #31708F;" onClick="hidePanel(this);";><small>' + Hide + '</small></span>');
    $(panel).parent().parent().show();
    var wholePanel = $(panel).parent();
    var panelHeader = $(wholePanel).first();
    var spanHeader = $(panelHeader).children().first().children().first().children().last().children().first();
    $(spanHeader).css("display", "");
}

function hidePanel(ob)
{
    var panel = $(ob).parent().parent().parent();
    var rows = $(panel).children();
    $(panel).parent().parent().hide();    
    $(panel).css("max-height", "350px");  
    rows.first().css("max-height", "300px");
    var temp = rows.last().children();
    temp.first().html('<span style="color: #31708F;" onClick="showPanel(this);";><small>' + showMore + '</small></span>');
    $(panel).parent().parent().show();  
    var wholePanel = $(panel).parent();
    var panelHeader = $(wholePanel).first();
    var spanHeader = $(panelHeader).children().first().children().first().children().last().children().first();
    $(spanHeader).css("display", "none");    
}

function hideHeaderPanel(ob){
    var panel = $(ob).parent().parent().parent().parent();
    var hide = panel.children().last().children().last().children().children().first();
    $(hide).click();
}


function stepTwo()
{
    jQuery('#WhmcsAnalyzerContent').load(document.URL + '?page=StepTwo', function(){
        init();
    });
}

function stepThree()
{
    jQuery('#WhmcsAnalyzerContent').load(document.URL + '?page=StepThree&ajax=1', function(){
        checkShowHide();
        $('#myTabs').click(function() {
            setTimeout(function(){ 
                checkShowHide();
            }, 500);
        });
    });
}

function showErrorMessage()
{
    $('#thereWereErrors').css("visibility", "");
}

function showSolution(ob)
{
    var spans = $(ob).parent().children();
    $(spans[0]).css('display', 'none');
    $(spans[1]).css('display', '');
    $(spans[2]).html('<small>' + hideSolutionLabel + '</small>'); 
    $(spans[2]).attr("onclick","hideSolution(this)");
}

function hideSolution(ob)
{
    var spans = $(ob).parent().children();
    $(spans[0]).css('display', '');
    $(spans[1]).css('display', 'none');
    $(spans[2]).html('<small>' + possibleSolutionLabel + '</small>'); 
    $(spans[2]).attr("onclick","showSolution(this)");    
}

$(window).bind('keydown', function(event) {
    if (event.ctrlKey || event.metaKey) {
        switch (String.fromCharCode(event.which).toLowerCase()) {
        case 'f':
            showAllPanels();
            showAllHooks();
        default:
            break;
        }
    }
});

function showAllPanels(){
    var panels = document.getElementsByName("WhmcsAnalizerPanel");
    for (var i = 0; i < panels.length; ++i) {
        var temp = panels[i];
        var tBody = $(temp).children().last();
        var tRow = $(tBody).children().last();
        var rLast = tRow.children().last();
        var ob = rLast.children().last();
        if(temp.offsetHeight > 350)
        {
            showPanel($(ob));
        }
    }
}

function showAllHooks(){
    var panels = document.getElementsByName("WhmcsAnalizerShowHideHooks");
    for (var i = 0; i < panels.length; ++i){
        showHookDetails(panels[i]);
    }
}

function generateHtacces(){
    var params = "htaccess=1&ajax=1";
    if(callHtaccesAjax(params)){
        req.onreadystatechange = function() {
            if(req.readyState == 4 && req.status == 200) {
                var response  = req.responseXML.documentElement;
                var commands = response.getElementsByTagName('command');
                for(var i=0; i < commands.length; i++) {
                    method = commands[i].getAttribute('method');
                    switch(method) {
                    case 'success':
                        var value = getNodeValue(commands[i], 'value');
                        var target = getNodeValue(commands[i], 'target'); 
                        var property = getNodeValue(commands[i], 'property');
                        var htmlValue = value + '<br />' + userLang + ': <strong>' + target + '</strong> <br />' + passLang + ': <strong>' + property + '</strong>';
                        $("#thereWereErrors").attr('class','alert alert-success');
                        $('#thereWereErrors').html(htmlValue, 'value');
                        $('#thereWereErrors').css("visibility", "");
                        $('#proceedButton').html( buttonProceed , 'value');
                        $('#proceedButton').attr("onclick","acceptAccess()");  
                        break;
                    case 'error':
                        var value = getNodeValue(commands[i], 'value');
                        $('#thereWereErrors').html(value, 'value');
                        $('#thereWereErrors').css("visibility", "");
                        break;                     
                    }
                }
            }
        }
    }    

}

function callHtaccesAjax(params){
    return loadXMLDoc(window.location.href+'?page=Htaccess', params);
}

function acceptAccess(){
    window.location = document.URL;
}

function showHideHookDetails(ob){
    var cont = $(ob).children().last();
    var arrow = $(ob).children().first().children().last().children().first();
    if($(cont).css('display') == 'none'){
        $(ob).children().last().css("display", "block");
        $(arrow).removeClass('glyphicon glyphicon-arrow-left');
        $(arrow).addClass('glyphicon glyphicon-arrow-down');        
    }else{
        $(ob).children().last().css("display", "none");   
        $(arrow).removeClass('glyphicon glyphicon-arrow-down');
        $(arrow).addClass('glyphicon glyphicon-arrow-left');        
    }
}
      
function showHookDetails(ob){
    var cont = $(ob).children().last();
    var arrow = $(ob).children().first().children().last().children().first();
    $(ob).children().last().css("display", "block");
    $(arrow).removeClass('glyphicon glyphicon-arrow-left');
    $(arrow).addClass('glyphicon glyphicon-arrow-down');     
}   
